/// <reference types="react" />
import PropTypes from 'prop-types';
import SearchForm from '../../molecule/search-form';
declare const propTypes: {
    title: PropTypes.Requireable<string>;
    onClear: PropTypes.Requireable<(...args: any[]) => any>;
    options: PropTypes.Requireable<(PropTypes.InferProps<{
        label: PropTypes.Requireable<string>;
        value: PropTypes.Requireable<string>;
        selected: PropTypes.Requireable<boolean>;
        ref: PropTypes.Requireable<string>;
        count: PropTypes.Requireable<number>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
    }> | null | undefined)[]>;
    searchOptions: PropTypes.Requireable<PropTypes.InferProps<{
        action: PropTypes.Requireable<string>;
        method: PropTypes.Requireable<string>;
        onSubmit: PropTypes.Requireable<(...args: any[]) => any>;
        onReset: PropTypes.Requireable<(...args: any[]) => any>;
        onSearchFocus: PropTypes.Requireable<(...args: any[]) => any>;
        onSearchBlur: PropTypes.Requireable<(...args: any[]) => any>;
        search: PropTypes.Requireable<PropTypes.InferProps<{
            value: PropTypes.Requireable<string>;
            placeholder: PropTypes.Validator<string>;
            onChange: PropTypes.Requireable<(...args: any[]) => any>;
            onClear: PropTypes.Requireable<(...args: any[]) => any>;
            onFocus: PropTypes.Requireable<(...args: any[]) => any>;
            onBlur: PropTypes.Requireable<(...args: any[]) => any>;
            theme: PropTypes.Requireable<string>;
            dataTestId: PropTypes.Requireable<string>;
        }>>;
        'search-reset-aria-label': PropTypes.Requireable<string>;
        dataTestId: PropTypes.Requireable<string>;
    }>>;
};
export declare type FilterCheckboxAndSearchOptions = {
    label: string;
    value: string;
    selected: boolean;
    ref: string;
    count: number;
    onClick: () => void;
};
export declare type FilterCheckboxAndSearchProps = {
    title: string;
    onClear: () => void;
    searchOptions: React.ComponentProps<typeof SearchForm>;
    options: FilterCheckboxAndSearchOptions[];
};
export default propTypes;
//# sourceMappingURL=props-types.d.ts.map